import {
  get,
  post
} from '../../utils/http';
Page({

  /**
   * 页面的初始数据
   */
  data: {
    current: 0,
    list: [],
    total: 0,
    page: 1,
    visible: false,
    order_id: 0
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.getCardList()
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    if(this.data.page * 10 < this.data.total) {
      this.getCardList(++this.data.page)
    }
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  /**
   * 切换状态
   */
  onTabsChange(e) {
    let current = e.currentTarget.dataset.id
    if(current == this.data.current) {
      return;
    }
    this.setData({
      current,
      page: 1,
    },() => {
      this.getCardList()
    })
  },

  /**
   * 打开激活弹框
   */
  onOpenPopup(e) {
    console.log(e)
    this.setData({ 
      visible:true,
      order_id:e.currentTarget.dataset.id
    })
  },

  /**
   * 暂不激活
   */
  onCancelUse() {
    this.setData({ visible: false })
  },

  /**
   * 确认激活
   */
  onConfirmUse(e) {
    let that = this;
    post('api/card/active',{
      order_id: this.data.order_id
    },(res) => {
      wx.showToast({
        title: res.msg,
        icon: 'none',
      })
      that.getCardList(1)
      this.setData({ visible: false })
    })
    
  },

  /**
   * 取消订单
  */
  onCancelOrder(e) {
    let that = this;
    wx.showModal({
      title: '提示',
      content: '是否取消当前订单',
      success (res) {
        console.log('用户点击确定')
        if (res.confirm) {
          post('api/card/refund',{
            order_id: e.currentTarget.dataset.id
          },(res) => {
            wx.showToast({
              title: res.msg,
              icon: 'success',
              duration: 2000
            })
            that.getCardList(1)
          })
        } else if (res.cancel) {
          console.log('用户点击取消')
        }
      }
    })
  },

  /**
   * 获取会员卡列表
   * /api/user/card
  */
  getCardList(_page) {
    let { list,current,page } = this.data;
    get('api/user/card',{
      type: Number(current)+1,
      page: _page || page,
      limit: 10
    },(res) => {
      if(_page == 1 || page == 1) {
        list = []
        this.data.page = 1
      }
      list.push(...res.data.list)
      this.setData({ list,total:res.data.total })
      console.log(res)
    })
  }
})